/* proxy router */
/* by Marek Zelem */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <netdb.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <signal.h>
#include <mmm/net_lib.h>
#include <time.h>

//#define	MAXCONF	64

typedef struct { char adr[128];
		 char proxy[128];
		 int port;
	       } conf_t;

conf_t	conf[MAXCONF];
int confs;

void budik( int signr )
{
	signal(signr,budik);
	return;
}


int next( const char *p, int pos )
{ int j;
	j=pos;
	while( j<confs && ( strlen(p)<strlen(conf[j].adr) || strcmp(p+strlen(p)-strlen(conf[j].adr),conf[j].adr) ) )	j++;
	if( j>=confs )	return(-1);
	return(j);
}

int porovnaj( const char *buf, char *p )
{ int i,j,c;
//  unsigned int ip;
	i=0;
	/* skip command */
	while( buf[i]!=' ' && buf[i]!='\t' && buf[i]!=0 ) i++;
	while( buf[i]==' ' || buf[i]=='\t' ) i++;
	if( strncmp(buf+i,"http://",7) )
	{	strcpy(p,"LOCAL");	return(0);	}
	i+=7; j=i;
	while( buf[j]!='/' && buf[j]!=0 && buf[j]>32 ) j++;
	for(c=i;c<j;)	{ p[c-i]=buf[c]; c++; }
	p[c-i]=0;
	net_maximalname(p);
// if( !net_name2ip(p,&ip) )
// 	ip=(unsigned int)inet_addr (p);
// net_ip2name(ip,p);
	return( 1 );
}

int vykonaj( char *buf )
{ int s,i,port;
  char *proxy;
  unsigned int ip;
  char p[1024];
  FILE *f;
  char str[4096];
	porovnaj(buf,p);
	i=0;
	do {
		i=next(p,i);
		if( i<0 )
			return(-1);
		proxy=conf[i].proxy;
		port=conf[i].port;
		i++;
		net_name2ip(proxy,&ip);
		signal(SIGALRM,budik);
		alarm(5l);
	   }
        while( (s=net_connect(ip,port))<0 );
	alarm(0l);
if( (f=fopen(LOGF,"a"))!=NULL )
{ time_t tim;
  char pom[128];
        tim=time(NULL);
        strcpy(pom,ctime(&tim)); if(pom[0]) pom[strlen(pom)-1]=0;
	sprintf(str,"%s user: %s\n%s%s %d\n---\n",pom,getenv("REMOTE_NAME"),buf,proxy,port);
	fwrite(str,strlen(str),1,f);
	fflush(f);
	fclose(f);
}
	write(s,buf,strlen(buf));
	net_tostdio(s,0,1);
	net_close(s);
	net_close(0);
	net_close(1);
	return(1);
}

int read_config( char *name )
{ FILE *f;
  int i;
  char s[4096];
	i=0;
	f=fopen(name,"r");
if( f==NULL && (f=fopen(LOGF,"a"))!=NULL )
{	sprintf(s,"! Can`t open config file %s\n",name);
	fwrite(s,strlen(s),1,f);
	fflush(f);
	fclose(f);  f=NULL;
}
	while( f!=NULL && i<(MAXCONF-1) && fgets(s,4096,f)!=NULL )
	{	if( s[0]==0 || s[1]==0 || s[2]==0 || s[0]=='#' )
			continue;
		if( sscanf(s,"%s %s %d",conf[i].adr,conf[i].proxy,&(conf[i].port))!=3 )
			continue;
		if( !strcmp(conf[i].adr,"DEFAULT") )
			conf[i].adr[0]=0;
// printf("adr: <%s> proxy: <%s> port: <%d>\n",conf[i].adr,conf[i].proxy,conf[i].port);
		i++;
	}
	conf[i].adr[0]=0;
	strcpy(conf[i].proxy,"localhost");
	conf[i].port=80;
	i++;
	confs=i;
	return(i);
}

int child( void )
{ char buf[4096];

// fgets(buf,4096,stdin);
	net_getln(0,buf,4096);
	vykonaj(buf);
	return(0);
}

int main( int argc, char *argv[] )
{ int i;
  char cfname[1024];
	strcpy(cfname,CNF);
	i=1;
	if( (i+1)<argc && !strcmp(argv[i],"-c") )
	{	i++;
		strcpy(cfname,argv[i]);	i++;
	}
	read_config(cfname);
	child();
	return(0);
}

